package app;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Dialog, in dem alle Fehlermeldungen der Applikation ausgegeben werden.
 * <i>(C)opyright 2002 L.H.Hahn</i>
 * @author Dr. Lars H. Hahn
 * @version 3.0
 */

public class DlgFehlerAusgabe
  extends JDialog {

  private final JTextArea textArea = new JTextArea(10,40);
  private final JPanel buttonPane = new JPanel();
  private final JButton loeschen = new JButton("Lschen");
  private final JButton verstecken = new JButton("Verstecken");

  public DlgFehlerAusgabe(JFrame owner) {
    super(owner, "Fehler-Ausgabe", false);
    buttonPane.add(loeschen);
    buttonPane.add(verstecken);
    loeschen.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        textArea.setEditable(true);
        textArea.selectAll();
        textArea.cut();
        textArea.setEditable(false);
      }
    });
    verstecken.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        hide();
      }
    });
    textArea.setEditable(false);
    textArea.setLineWrap(true);
    textArea.setWrapStyleWord(true);
    this.getContentPane().add(new JScrollPane(textArea), BorderLayout.NORTH);
    this.getContentPane().add(Box.createRigidArea(new Dimension(0,5)), BorderLayout.CENTER);
    this.getContentPane().add(buttonPane, BorderLayout.SOUTH);
    this.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
  }

  /**
   * Gibt einen Fehlermeldung <i>ohne</i> Zeilenwechsel aus.
   * <ul>
   * <li> -I- Information
   * <li> -W- Warnung
   * <li> -E- Fehler (Error)
   * </ul>
   * @param test Fehlermeldung
   */
  public void print(String text) {
    textArea.append(text);
  }

  /**
   * Gibt einen Fehlermeldung <i>mit</i> Zeilenwechsel aus.
   * <ul>
   * <li> -I- Information
   * <li> -W- Warnung
   * <li> -E- Fehler (Error)
   * </ul>
   * @param test Fehlermeldung
   */
  public void println(String text) {
    show();
    textArea.append(text+"\n");
  }

}