package haushalt;
import haushalt.werte.ZeitIntervall;
import app.Applikation;

import java.awt.event.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.table.*;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class DlgAutoBuchung
  extends JDialog
  implements KeyListener {

  private final static boolean DEBUG = false;

  private final AutoBuchung autoBuchung;

  public DlgAutoBuchung(JFrame masterFrame, AutoBuchung autoBuchung) {
    super(masterFrame, "automatische Buchungen");
    this.autoBuchung = autoBuchung;
    JTable table = new JTable(autoBuchung);
    table.setPreferredScrollableViewportSize(new Dimension(500,500));
    BuchungsEditor buchungsEditor = new BuchungsEditor(masterFrame);
    table.setDefaultEditor(Buchung.class, buchungsEditor);
    table.setDefaultRenderer(Buchung.class, new BuchungsRenderer());
    table.setDefaultEditor(Register.class, new DefaultCellEditor(new JComboBox(Register.getRegister())));
    table.setDefaultEditor(String.class, new DefaultCellEditor(new JComboBox(autoBuchung.intervallNamen)));
    table.addKeyListener(this);
    this.getContentPane().add(new JScrollPane(table));
  }

  public void showDialog() {
    pack();
    setVisible(true);
  }

  public void keyReleased(KeyEvent e) {
    if(DEBUG)
      System.out.println("DlgAutoBuchung: KeyCode="+e.getKeyCode());

    if(e.getSource().getClass() == JTable.class) {
      JTable table = (JTable)e.getSource();
      if((e.getModifiers() == 8) && (e.getKeyCode() == 'D')) { // Alt-D
        int row = table.getSelectedRow();
        if(row == -1) {
          table.getCellEditor().cancelCellEditing();
          JOptionPane.showMessageDialog(this,
            "Keine Zeile selektiert!",
            "Alt-D: Automatische Buchung",
            JOptionPane.WARNING_MESSAGE);
        }
        else {
          TableCellEditor cellEditor = table.getCellEditor();
          if(cellEditor != null)
            cellEditor.cancelCellEditing();
          autoBuchung.delBuchung(table.getSelectedRow());
        }
      }
    }
    else
      Applikation.fehlerAusgabe.println("-E- Ups! KeyEvent von "+e.getSource());
  }

  public void keyPressed(KeyEvent e){};

  public void keyTyped(KeyEvent e){};
}