package haushalt;
import haushalt.werte.Datum;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * @author Lars H. Hahn
 * @version 1.1
 */

public class DlgMaster
  extends JDialog {

  private JPanel paneContainer = new JPanel();
  private JPanel paneButton = new JPanel();
  private final JButton buttonOK = new JButton("OK");
  private final JButton buttonAbbruch = new JButton("Abbruch");
  private boolean OK = false;
  private JComponent letzteKomponente = null;

  public DlgMaster(String text, Frame owner) {
    super(owner, text, true);

    paneButton.add(buttonOK, null);
    paneButton.add(buttonAbbruch, null);
    paneContainer.setLayout(new BoxLayout(paneContainer, BoxLayout.Y_AXIS));
    this.getContentPane().add(paneContainer, BorderLayout.CENTER);
    this.getContentPane().add(paneButton, BorderLayout.SOUTH);

    buttonOK.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        OK = true;
        setVisible(false);
      }
    });
    buttonAbbruch.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        setVisible(false);
      }
    });
    getRootPane().setDefaultButton(buttonOK);
  }

  public boolean showDialog() {
    setLocationRelativeTo(this.getOwner());
    pack();
    setVisible(true);
    return OK;
  }

  public void addPane(final PaneMaster pane) {
    pane.setNummer(paneContainer.getComponentCount()+1);
    paneContainer.add(pane);
    final JComponent neueKomponente = pane.getZentraleKomponente();
    if(letzteKomponente == null)
      buttonOK.setNextFocusableComponent(neueKomponente);
    else
      letzteKomponente.setNextFocusableComponent(neueKomponente);
    neueKomponente.setNextFocusableComponent(buttonOK); // vorsorglich, falls die Letzte

    neueKomponente.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        pane.refreshWert();
      }
    });

    letzteKomponente = neueKomponente;
  }

  public static void main(String[] args) {
    JFrame frame = new JFrame("DlgMasterDemo");
    DlgMaster dlg = new DlgMaster("DlgMaster", frame);
    PaneDatum pane1 = new PaneDatum("Bitte geben Sie ein Datum ein:", new Datum("28.03.70"));
    dlg.addPane(pane1);
    PaneKategorie pane2 = new PaneKategorie("Bitte whlen Sie ein Register aus:",
                                        Register.getRegisterNamen());
    dlg.addPane(pane2);

    frame.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {System.exit(0);}
    });

    frame.pack();
    frame.setVisible(true);
    if(dlg.showDialog())
      System.out.println("OK:"+pane1.getWert()+" / "+pane2.getWert());
    else
      System.out.println("Abbruch!");
  }

}