package haushalt.werte;

import javax.swing.JTextField;
import javax.swing.text.*;
import java.awt.Toolkit;
import java.text.ParseException;
import java.util.Locale;
import java.awt.event.*;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class DatumField
  extends JTextField {

  public DatumField() {
    super(8); // 8 Spalten
    setValue(new Datum());
  }

  public DatumField(Datum datum) {
    super(8); // 8 Spalten
    setValue(datum);
  }

  public Datum getValue() {
    return new Datum(getText());
  }

  public void setValue(Datum datum) {
    setText(datum.toString());
  }

  protected Document createDefaultModel() {
    return new DatumDocument();
  }

  private class DatumDocument extends PlainDocument {
    public void insertString(int offs, String str, AttributeSet a)
      throws BadLocationException {
      char[] source = str.toCharArray();
      char[] result = new char[8]; // max. 8 Zeichen: tt.mm.yy
      int j = 0;
      int anzChar = (source.length < 8)?source.length:8;

      for (int i = 0; i < anzChar; i++) {
        if (((source[i] == '.') || (source[i] == '-')) && ((offs+i == 2) || (offs+i == 5))) {
          result[j++] = '.';
        }
        else {
          if (Character.isDigit(source[i])) {
            if((offs+i == 2) || (offs+i == 5)) {
              result[j++] = '.';
            }
            result[j++] = source[i];
          }
        }
      }
      if(j+getLength() > 8)
        j = 8 - getLength();
      super.insertString(offs, new String(result, 0, j), a);
    }
  }
}