package haushalt.werte;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class Jahr
  extends ZeitIntervall {

  private int jahr = 2000;

  public Jahr(int jahr) {
    this.jahr = jahr;
  }

  public Jahr(String jahr) {
    try {
      this.jahr = Integer.parseInt(jahr);
    }
    catch(Exception e) {
      // Fehler! -> Standardwerte.
    }
  }

  public Datum getStartDatum() {
    return new Datum("01.01."+jahr);
  }

  public Datum getEndDatum() {
    return new Datum("01.01."+(jahr+1));
  }

  public ZeitIntervall folgeIntervall() {
    return new Jahr(jahr+1);
  }

  public String toString() {
    return ""+jahr;
  }

}