package haushalt.werte;

import java.util.StringTokenizer;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class Monat
  extends ZeitIntervall {

  private int monat = 1;
  private int jahr  = 2000;

  public Monat(int monat, int jahr) {
    this.monat = monat;
    this.jahr = jahr;
  }

  public Monat(String text) {
    try {
      StringTokenizer st = new StringTokenizer(text, "/");
      monat = Integer.parseInt(st.nextToken());
      jahr = Integer.parseInt(st.nextToken());
      if(monat > 12)
        monat = 12;
    }
    catch(Exception e) {
      // Fehler! -> Standardwerte.
    }
  }

  public Datum getStartDatum() {
      return getMonatsBeginn(monat, jahr);
  }

  public Datum getEndDatum() {
    if(monat == 12)
      return getMonatsBeginn(1, jahr+1);
    else
      return getMonatsBeginn(monat+1, jahr);
  }

  public ZeitIntervall folgeIntervall() {
    if(monat == 12)
      return new Monat(1, jahr+1);
    else
      return new Monat(monat+1, jahr);
  }

  private static Datum getMonatsBeginn(int monat, int jahr) {
    return new Datum("01."+monat+"."+jahr);
  }

  public String toString() {
    return ""+monat+"/"+jahr;
  }

}