package haushalt.werte;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class TortenWert {

    private String kategorie;
    private Euro wert;

    public TortenWert(Euro wert, String kategorie) {
      this.wert = wert;
      this.kategorie = kategorie;
    }

    public String getKategorie() {
      return kategorie;
    }

    public Euro getWert() {
      return wert;
    }

    public double prozent(Euro gesamtSumme) {
      return wert.toDouble() / gesamtSumme.toDouble();
    }

    public boolean groesser(TortenWert vergleich) {
      return wert.compareTo(vergleich.wert) > 0;
    }

    public boolean ungleichNull() {
      return !wert.equals(Euro.NULL_EURO);
    }
}