package haushalt.werte;

/**
 * Teil des Paketes 'werte' des Projektes jHaushalt.
 *
 * @author Lars H. Hahn
 * @version 1.1
 */

public class VollesJahrBisDatum
  extends ZeitIntervall {

  private int tag;
  private int monat;
  private int jahr;

  public VollesJahrBisDatum(int tag, int monat, int jahr) {
    this.tag = tag;
    this.monat = monat;
    this.jahr = jahr;
  }

  public VollesJahrBisDatum(Datum datum) {
    this.tag = datum.getTag();
    this.monat = datum.getMonat();
    this.jahr = datum.getJahr();
  }

  public Datum getStartDatum() {
    return new Datum(tag, monat, jahr-1);
  }

  public Datum getEndDatum() {
    return new Datum(tag, monat, jahr);
  }

  public ZeitIntervall folgeIntervall() {
    return new VollesJahrBisDatum(tag, monat, jahr+1);
  }

  public String toString() {
    return ""+getStartDatum()+"-"+getEndDatum();
  }

}